/***************************************************************************
*    Funktion: Headerfile fr UEXEC-Multitasking                           *
****************************************************************************/
#ifndef _UEXEC_H
#define _UEXEC_H
/* header file micro-executive
 * based on exec software
 * copyright: Richard F. Man
 * modified:  Jens Altenburg
 */


/* Number of tasks, change this to suit your need
 */
#define NUM_TASKS   4

int UEXC_CreateTask(void (*func)(void),
                    unsigned char *stack_start,
                    unsigned stack_size,
                    unsigned ticks);
void UEXC_Defer        ( void );
void UEXC_HogProcessor ( void );
void UEXC_KillTask     ( int pid );
void UEXC_CheckTask    ( void ); /* @JA */
void UEXC_KillSelf	   ( void ); /* @JA */
void UEXC_Schedule	   ( void ); /* @JA */

int UEXC_StartScheduler( void );

extern void (*UEXC_InterruptDriver)(void);

extern unsigned char *uexc_current_sp;
extern void (*uexc_current_func)(void);

/* Minimum stack size for a task function that does not use "any" stack space.
 * This should be the interrupt stack frame, plus some fudge factor for
 * frame pointer, a single function call, etc.
 */
#define UEXC_MIN_STACK_SIZE     (60)    /* Minimale Stackgre */

#define INTR_ON()        asm("eint")
#define INTR_OFF()       asm("dint")


#endif
